{
  description = "IP-Checker-GUI packaged with Nix flake";

  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixos-24.05"; # or unstable
    flake-utils.url = "github:numtide/flake-utils";
  };

  outputs = { self, nixpkgs, flake-utils }:
    flake-utils.lib.eachDefaultSystem (system:
      let
        pkgs = import nixpkgs {
          inherit system;
        };
        rustPlatform = pkgs.rustPlatform;
      in {
        packages.default = rustPlatform.buildRustPackage {
          pname = "ip-checker-gui";
          version = "0.1.0";

          src = pkgs.fetchFromGitHub {
            owner = "TimTom2016";
            repo = "IP-Checker-GUI";
            rev = "master"; # or pin a commit
            sha256 = "sha256-FO8jNXkiRQz/jDEydVjCH6O1qGSxnKUJhTnOOINpOMg="; # replace with actual hash
          };

          nativeBuildInputs = [ pkgs.pkg-config ];
          buildInputs = [ pkgs.gtk4 ];

          cargoLock = {
            lockFile = ./Cargo.lock;
          };
        };
      });
}

